Imports Sample_VolaSmsPlus_VB.Vola.VolaSmsPlus

Public Class frmSendSMS

    Private Sub lnkVola_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkVola.LinkClicked
        'Apre una shell del browser con il sito di Vola
        System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkHomePage)
    End Sub

    Private Sub lnkSupporto_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkSupporto.LinkClicked
        'Apre una shell del browser con il sito di Vola
        System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkSupport)
    End Sub

    Private Sub lnkLicenza_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkLicenza.LinkClicked
        Try
            'Apre una shell del blocco di testo con la licenza
           Dim sPathUpdate As String = Application.StartupPath + "\..\..\Licenza\gplv3-it-final.pdf"

            Dim proc As New System.Diagnostics.Process()
            proc.EnableRaisingEvents = False
            proc.StartInfo.FileName = sPathUpdate
            proc.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized
            proc.Start()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub cmdClose_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Me.Close()
    End Sub



    Private Sub CmdInvio_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CmdInvio.Click
        Try
            Dim sMessage As String
            Dim Volasms As New Vola.VolaSmsPlus.VolaSmsPlus()

            'Inizializzo il componente con le propriet di autenticazione
            Volasms.UserName = txtUsername.Text
            Volasms.Password = txtPassword.Text
            Volasms.VapCode = ""

            'Inizializzo il componente con le propriet di connessione
            Volasms.AutomaticProxy = True
            Volasms.EncryptSSL = True

            'per effettuare test senza consumare il credito VolaSMS, la
            'propriet test mode deve essere impostata a true
            'in questo caso il messaggio SMS non viene recapitato, ma la comunicazione con
            'il gateway avviene regolarmente
            If chkTest.Checked = True Then
                Volasms.TestMode = True
            Else
                Volasms.TestMode = False
            End If

            Volasms.ClearMessageToSend()

            'Se si vuole mnadare messaggi lunghi occore impostare l'opzione
            Volasms.LongMessage = True

            'Aggiungo il messaggio nella lista
            'Se si hanno pi destinatari da mandare un messaggio uguale conviene passare un array di stringhe
            'come primo parametro per rendere il comando di invio pi veloce ed efficace.
            Dim Messaggio As Vola.VolaSmsPlus.VolaMessaggio = Volasms.AddMessageToSend(txtDestinatario.Text.Split(","c), txtText.Text, cmbMittente.Text, DateTime.Now)
            If Messaggio Is Nothing Then
                sMessage = "Messaggio non inserito correttamente nella lista dei messaggi da inviare."
                MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                Exit Sub
            End If
            Dim Msdn As Vola.VolaSmsPlus.VolaMsdn = DirectCast(Messaggio.listaDestinatari(0), Vola.VolaSmsPlus.VolaMsdn)
            If Msdn.status <> Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_INLIST Then
                sMessage = "Messaggio non inserito correttamente nella lista dei messaggi da inviare."
                MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                Exit Sub
            End If

            'E' possibile aggiungere pi messaggi alla lista in modo che con un unico invio  possibile mandare messaggi diversi a destintari diversi
            'Il numero massimo  1000

            'Prima di inviare controllo lo stato della lista
            If Volasms.CountMessageToSend() <= 0 Then
                sMessage = "Impossibile continuare con l'invio di SMS perch non sono presenti messaggi corretti nella lista."
                MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                Exit Sub
            End If

            'Invio il messaggio
            If Volasms.SendMessageToSend() = False Then
                sMessage = "Messaggio non inviato correttamente"
                MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                Exit Sub
            End If

            'Verifico lo stato del messaggio inviato
            Select Case Msdn.status
                Case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRPHONEGSM
                    sMessage = "Messaggio non inviato al numero: " & Msdn.gsm & " perch il destinatarrio non  corretto"
                    Exit Select
                Case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRDATETIME
                    sMessage = "Messaggio non inviato al numero: " & Msdn.gsm & " perch la data e ora erano nel formato non  corretto"
                    Exit Select
                Case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRGATEWAY
                    sMessage = "Messaggio non inviato al numero: " & Msdn.gsm & " perch scartato dal Gateway"
                    Exit Select
                Case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRSENDER
                    sMessage = "Messaggio non inviato al numero: " & Msdn.gsm & " perch il mittente  errato"
                    Exit Select
                Case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_ERRTEXT
                    sMessage = "Messaggio non inviato al numero: " & Msdn.gsm & " perch incompleto"
                    Exit Select
                Case Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_SENT
                    'il messaggio  andato a buon fine
                    txtOrderid.Text = ""
                    For iCount As Integer = 0 To Messaggio.orderid.Length - 1
                        txtOrderid.Text = txtOrderid.Text + Messaggio.orderid(iCount) & ","
                    Next
                    Dim credito As String = Volasms.GetCreditSMS()
                    sMessage = "Messaggio inoltrato. Il credito residuo di VolaPlus : " & credito
                    Exit Select
                Case Else
                    sMessage = "Messaggio non inviato al numero: " & Msdn.gsm & " a causa di un errore nel protocollo"
                    Exit Select
            End Select
            MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)

        Catch ex As Vola.VolaSmsPlus.VolaException
            MessageBox.Show(("Errore libreria Vola: " & ex.Codice & vbCr & vbLf & vbCr & vbLf) + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub cmdAggiorna_Click(ByVal sender As Object, ByVal e As EventArgs) Handles cmdAggiorna.Click
        Try
            Dim Volasms As New Vola.VolaSmsPlus.VolaSmsPlus()

            'Inizializzo il componente con le propriet di autenticazione
            Volasms.UserName = txtUsername.Text
            Volasms.Password = txtPassword.Text
            Volasms.VapCode = ""

            'Inizializzo il componente con le propriet di connessione
            Volasms.AutomaticProxy = True
            Volasms.EncryptSSL = True

            If Volasms.CountListSender() = 0 Then
                If Not Volasms.GetListSender() Then
                    MessageBox.Show("Errore nella ricezione della lista mittenti Vola" & vbCr & vbLf & vbCr & vbLf, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
            End If

            cmbMittente.Items.Clear()
            Dim TEnumerator As IEnumerator = Volasms.ListSender.GetEnumerator()
            Dim Mittente As Vola.VolaSmsPlus.VolaSender
            For iCount As Integer = 1 To Volasms.ListSender.Count
                TEnumerator.MoveNext()

                Mittente = DirectCast(TEnumerator.Current, Vola.VolaSmsPlus.VolaSender)
                cmbMittente.Items.Add(Mittente.mittente)
                If Mittente.type = Vola.VolaSmsPlus.VolaTypeSender.PREDEFINITO Then
                    cmbMittente.Text = Mittente.mittente
                End If
            Next
            Exit Sub

        Catch ex As Vola.VolaSmsPlus.VolaException
            MessageBox.Show(("Errore libreria Vola: " & ex.Codice & vbCr & vbLf & vbCr & vbLf) + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub


End Class